1. Introduction
Every graph in this paper is finite, undirected, connected, and has at most one edge between any two vertices in G. We assume that the vertex set V and edge set E of G contain n vertices and m edges. They can also be denoted by and . A graph is an induced subgraph of G denoted by if and contains all the edge for . Two vertices are adjacent or neighbors if . The sets and are the neighborhood and closed neighborhood of a vertex x in G, respectively. The number is the degree of x in G. If for every , then G is k-regular. Particularly, cubic graphs are an alternative name for 3-regular graphs.
A subset S of V is a clique if for . Let Q be a clique of G. If for any other clique of G, then Q is a maximal clique. We use to represent the set is a maximal clique of . A clique is a maximum clique if for every . The number is the clique number of G. A set is a clique transversal set (abbreviated as CTS) of G if for every . The number is a CTS of is the clique transversal number of G. The clique transversal problem (abbreviated as CTP) is to find a minimum CTS for a graph. A set is a clique independent set (abbreviated as CIS) of G if or and for . The number is a CIS of is the clique independence number of G. The clique independence problem (abbreviated as CIP) is to find a maximum CIS for a graph.
The CTP and the CIP have been widely studied. Some studies on the CTP and the CIP consider imposing some additional constraints on CTS or CIS, such as the maximum-clique independence problem (abbreviated as MCIP), the k-fold clique transversal problem (abbreviated as k-FCTP), and the maximum-clique transversal problem (abbreviated as MCTP).
Definition 1 ([
1,
2])
. Suppose that is fixed and G is a graph. A set is a k-fold clique transversal set (abbreviated as k-FCTS) of G if for . The number is a k-FCTS of is the k-fold clique transversal number of G. The k-FCTP is to find a minimum k-FCTS for a graph. Definition 2 ([
3,
4])
. Suppose that G is a graph. A set is a maximum-clique transversal set (abbreviated as MCTS) of G if for with . The number is an MCTS of is the maximum-clique transversal number of G. The MCTP is to find a minimum MCTS for a graph. A set is a maximum-clique independent set (abbreviated as MCIS) of G if for and for . The number is an MCIS of is the maximum-clique independence number of G. The MCIP is to find a maximum MCIS for a graph. The
k-FCTP on balanced graphs can be solved in polynomial time [
2]. The MCTP has been studied in [
3] for several well-known graph classes and the MCIP is polynomial-time solvable for any graph
H with
[
4]. Assume that
and
is a function. Let
for
, and let
be the
weight of
f. A CTS of
G can be expressed as a function
f whose domain is
and range is
, and
for
. Then,
f is a
clique transversal function (abbreviated as CTF) of
G and
is a CTF of
. Several types of CTF have been studied [
4,
5,
6,
7]. The following are examples of CTFs.
Definition 3. Suppose that is fixed and G is a graph. A function f is a -clique transversal function (abbreviated as -CTF) of G if the domain and range of f are and , respectively, and for . The number is a -CTF of is the -clique transversal number of G. The -clique transversal problem (abbreviated as -CTP) is to find a minimum-weight -CTF for a graph.
Definition 4. Suppose that G is a graph. A function f is a signed clique transversal function (abbreviated as SCTF) of G if the domain and range of f are and , respectively, and for . If the domain and range of f are and , respectively, and for , then f is a minus clique transversal function (abbreviated as MCTF) of G. The number is an SCTF of is the signed clique transversal number of G. The minus clique transversal number of G is is an MCTF of . The signed clique transversal problem (abbreviated as SCTP) is to find a minimum-weight SCTF for a graph. The minus clique transversal problem (abbreviated as MCTP) is to find a minimum-weight MCTF for a graph.
Lee [
4] introduced some variations of the
k-FCTP, the
-CTP, the SCTP, and the MCTP, but those variations are dedicated to maximum cliques in a graph. The MCTP on chordal graphs is NP-complete, while the MCTP on block graphs is linear-time solvable [
7]. The MCTP and SCTP are linear-time solvable for any strongly chordal graph
G if a
strong elimination ordering of
G is given [
5]. The SCTP is NP-complete for doubly chordal graphs [
6] and planar graphs [
5].
According to what we have described above, there are very few algorithmic results regarding the k-FCTP, the -CTP, the SCTP, and the MCTP on graphs. This motivates us to study the complexities of the k-FCTP, the -CTP, the SCTP, and the MCTP. This paper also studies the MCTP and MCIP for some graphs and investigates the relationships between different dominating functions and CTFs.
Definition 5. Suppose that is fixed and G is a graph. A set is a k-tuple dominating set (abbreviated as k-TDS) of G if for . The number is a k-TDS of is the k-tuple domination number of G. The k-tuple domination problem (abbreviated as k-TDP) is to find a minimum k-TDS for a graph.
Notice that a dominating set of a graph G is a 1-TDS. The domination number of G is .
Definition 6. Suppose that is fixed and G is a graph. A function f is a -dominating function (abbreviated as -DF) of G if the domain and range of f are and , respectively, and for . The number is a -DF of is the -domination number of G. The -domination problem (abbreviated as -DP) is to find a minimum-weight -DF for a graph.
Definition 7. Suppose that G is a graph. A function f is a signed dominating function (abbreviated as SDF) of G if the domain and range of f are and , respectively, and for . If the domain and range of f are and , respectively, and for , then f is a minus dominating function (abbreviated as MDF) of G. The number is an SDF of is the signed domination number of G. The minus domination number of G is is an MDF of . The signed domination problem (abbreviated as SDP) is to find a minimum-weight SDF for a graph. The minus domination problem (abbreviated as MDP) is to find a minimum-weight MDF for a graph.
Our main contributions are as follows.
- 1.
We prove in
Section 2 that
and
for any sun
G. We also prove that
and
for any sun
G if
.
- 2.
We prove in
Section 3 that
for any graph
G with
. Then,
is polynomial-time solvable if
can be computed in polynomial time. We also prove that the SCTP is a special case of
the generalized clique transversal problem [
8]. Therefore, the SCTP for a graph
H can be solved in polynomial time if the generalized transversal problem for
H is polynomial-time solvable.
- 3.
We show in
Section 4 that
and
for any split graph
G. Furthermore, we introduce
-
split graphs and prove that
and
for any
-split graph
H. We prove the NP-completeness of SCTP for split graphs by showing that the SDP on
-split graphs is NP-complete.
- 4.
We show in
Section 5 that
for a
doubly chordal graph G can be computed in linear time, but the
k-FCTP is NP-complete for doubly chordal graphs as
. Notice that the CTP is a special case of the
k-FCTP and the
-CTP when
, and thus
for any graph
G.
- 5.
We present other NP-completeness results in
Section 6 and
Section 7 for
k-trees with unbounded
k and subclasses of total graphs, line graphs, and planar graphs. These results can refine the “borderline” between P and NP for the considered problems and graphs classes or their subclasses.
2. Suns
In this section, we give equations to compute , , , and for any sun G and show that , , , and .
Let
and
G be a graph. An edge
is a
chord if
e connects two non-consecutive vertices of a cycle in
G. If
C has a chord for every cycle
C consisting of more than three vertices,
G is a
chordal graph. A
sun G is a chordal graph whose vertices can be partitioned into
and
such that (1)
W is an independent set, (2) the vertices
of
U form a cycle, and (3) every
is adjacent to precisely two vertices
and
, where
(mod
p). We use
to denote a sun. Then,
. If
p is odd,
is an
odd sun; otherwise, it is an
even sun.
Figure 1 shows two suns.
Lemma 1. For any sun , and .
Proof. It is straightforward to see that U is a minimum 2-FCTS and is a minimum 3-FCTS of . This lemma therefore holds. □
Lemma 2. Suppose that and . Then, for any sun .
Proof. Let
such that
(mod
p). Since every
is adjacent to precisely two vertices
,
is a maximal clique of
. By contradiction, we can prove that there exists a minimum
-CTF
f of
such that
for
. Since
for
, we have
Since is a nonnegative integer, .
We define a function by for every , for with odd index i and for every with even index i. Clearly, a maximal clique Q of is either the closed neighborhood of some vertex in W or a set of at least three vertices in U. If for some , then . Suppose that Q is a set of at least three vertices in U. Since , . Therefore, h is a -CTF of . We show the weight of h is by considering two cases as follows.
Case 1:
p is even. We have
Case 2:
p is odd. We have
Following what we have discussed above, we know that h is a minimum -CTF of and thus . □
Lemma 3. For any sun ,
Proof. For
,
is a maximal clique of
. Let
h be a minimum SCTF of
. Then,
. Note that
for
. We have
Since , we have . Let f be an SCTF of such that and for . The weight of f is 0. Then f is a minimum SCTF of . Hence, and . The proof for is analogous to that for . □
Theorem 1 (Lee and Chang [
9])
. Let be a sun. Then,- (1)
;
- (2)
;
- (3)
, and .
Corollary 1. Letbe a sun. Then,
- (1)
;
- (2)
for ;
- (3)
and .
Proof. The corollary holds by Lemmas 1–3 and Corollary 1. □
3. Clique Perfect Graphs
Let be the set of all induced subgraphs of G. If for every , then G is clique perfect. In this section, we study the -CTP for clique perfect graphs and the SCTP for balanced graphs.
Lemma 4. Let G be such a graph that . Then, .
Proof. Assume that D is a minimum CTS of G. Then, . Let and let f be a function whose domain is and range is , and if ; otherwise, . Clearly, f is a -CTF of G. We have .
Assume that f is a minimum-weight -CTF of G. Then, and for every . Let be a maximum CIS of G. We know that and . Therefore, . Following what we have discussed above, we know that . □
Theorem 2. If a graph G is clique perfect, .
Proof. Since G is clique perfect, . Hence, the theorem holds by Lemma 4. □
Corollary 2. The -CTP is polynomial-time solvable for distance-hereditary graphs, balanced graphs, strongly chordal graphs, comparability graphs, and chordal graphs without odd suns.
Proof. Distance-hereditary graphs, balanced graphs, strongly chordal graphs, comparability graphs, and chordal graphs without odd suns are clique perfect, and the CTP can be solved in polynomial time for them [
10,
11,
12,
13,
14]. The corollary therefore holds. □
Definition 8. Suppose that R is a function whose domain is and range is . If for every , then R is a clique-size restricted function (abbreviated as CSRF) of G. A set is an R-clique transversal set (abbreviated as R-CTS) of G if R is a CSRF of G and for every . Let is an R-CTS of . The generalized clique transversal problem (abbreviated as GCTP) is to find a minimum R-CTS for a graph G with a CSRF R.
Lemma 5. Let G be a graph with a CSRF R. If for every , then .
Proof. Assume that D is a minimum R-CTS of G. Then, . Let and let f be a function of G whose domain is and range is , and if ; otherwise, . Since for every , there are at least vertices in C with the function value 1. Therefore, for every , and f is an SCTF of G. Then, .
Assume that h is a minimum-weight SCTF of G. Clearly, . Since for every , C contains at least vertices with the function value 1. Let . The set D is an R-CTS of G. Therefore, . Hence, we have . □
Theorem 3. The SCTP on balanced graphs can be solved in polynomial time.
Proof. Suppose that a graph
G has
n vertices
and
ℓ maximal cliques
. Let
and
. Let
M be an
matrix such that an element
of
M is one if the maximal clique
contains the vertex
, and
otherwise. We call
M the
clique matrix of
G. If the clique matrix
M of
G does not contain a square submatrix of odd order with exactly two ones per row and column, then
M is a
balanced matrix and
G is a
balanced graph. We formulae the GCTP on a balanced graph
G with a CSRF
R as the following integer programming problem:
where
is a column vector and
is a column vector such that
is either 0 or 1. Since the matrix
M is balanced, an optimal 0–1 solution of the integer programming problem above can be found in polynomial time by the results in [
15]. By Lemma 5, we know that the SCTP on balanced graphs can be solved in polynomial time. □
4. Split Graphs
Let G be such a graph that and . If I is an independent set and C is a clique, G is a split graph. Then, every maximal of G is either C itself, or the closed neighborhood of a vertex . We use to represent a split graph. The -CTP, the k-FCTP, the SCTP, and the MCTP for split graphs are considered in this section. We also consider the -DP, the k-TDP, the SDP, and the MDP for split graphs.
For split graphs, the
-DP, the
k-TDP, and the MDP are NP-complete [
16,
17,
18], but the complexity of the SDP is still unknown. In the following, we examine the relationships between the
-CTP and the
-DP, the
k-FCTP and the
k-TDP, the SCTP and the SDP, and the MCTP and the MDP. Then, by the relationships, we prove the NP-completeness of the SDP, the
-CTP, the
k-FCTP, the SCTP, and the MCTP for split graphs. We first consider the
-CTP and the
k-FCTP and show in Theorems 4 and 5 that
and
for any split graph
G. Chordal graphs form a superclass of split graphs [
19]. The cardinality of
is at most
n for any chordal graph
G [
20]. The following lemma therefore holds trivially.
Lemma 6. The k-FCTP, the -CTP, the SCTP, and the MCTP for chordal graphs are in NP.
Theorem 4. Suppose that and is a split graph. Then, .
Proof. Let S be a minimum k-FCTS of G. Consider a vertex . By the structure of G, is a maximal clique of G. Then, . We now consider a vertex . If , then there exists a vertex such that . Clearly, and . If , then . Hence, S is a k-TDS of G. We have .
Let D be a minimum k-TDS of G. Recall that the closed neighborhood of every vertex in I is a maximal clique. Then, D contains at least k vertices in the maximal clique for every vertex . If , D is clearly a k-FCTS of G. Suppose that . We consider three cases as follows.
Case 1: . Then, . The set D is a k-FCTS of G.
Case 2: and . Then, the set is still a minimum k-TDS and . The set is a k-FCTS of G.
Case 3: and for every . Then, . Since , there exists such that . If , then and . Otherwise, let . Then, and . The set D is a k-FCTS of G.
By the discussion of the three cases, we have . Hence, we obtain that and . The theorem holds for split graphs. □
Theorem 5. Suppose that and is a split graph. Then, .
Proof. We can verify by contradiction that G has a minimum-weight -CTF f and a minimum-weight -DF g of G such that and for every . By the structure of G, for every . Then, and . Since and , and .
For every , and . For every , . Therefore, the function f is also a -DF of G. We have . We now consider for the clique C. If , the function g is clearly a -CTF of G. Suppose that . Notice that g is a -DF and for every . Then, for any vertex . Therefore, g is also a -CTF of G. We have . Following what we have discussed above, we know that . □
Corollary 3. The -CTP and the k-FCTP are NP-complete for split graphs.
Proof. The corollary holds by Theorems 4 and 5 and the NP-completeness of the
-DP and the
k-TDP for split graphs [
16,
18]. □
A graph G is a complete if . Let G be a complete graph and let . The vertex set is the union of the sets and . Clearly, is an independent set and is a clique of G. Therefore, complete graphs are split graphs. It is easy to verify the Lemma 7.
Lemma 7. If G is a complete graph and, then
- (1)
for ;
- (2)
;
- (3)
;
- (4)
For split graphs, however, the signed and minus domination numbers are not necessarily equal to the signed and minus clique transversal numbers, respectively.
Figure 2 shows a split graph
G with
. However,
. We therefore introduce
-split graphs and show in Theorem 6 that their signed and minus domination numbers are equal to the signed and minus clique transversal numbers, respectively.
-split graphs are motivated by the graphs in [
17] for proving the NP-completeness of the MDP on split graphs.
Figure 3 shows an
-split graph.
Definition 9. Suppose thatis a split graph withvertices. Let U, S, X, and Y be pairwise disjoint subsets ofsuch that,,, and. The graph G is an-split graph ifand G entirely satisfies the following three conditions.
- (1)
and .
- (2)
for .
- (3)
and for .
Theorem 6. For any -split graph , and .
Proof. We first prove . Let be an -split graph. As stated in Definition 9, I can be partitioned into and , and C can be partitioned into and . Assume that f is a minimum-weight SDF of G. For each , and is adjacent to only the vertex . Then, for . Since and , we know that . Notice that and for every . Therefore, f is also an SCTF of G. We have .
Assume that h is a minimum-weight SCTF of G. For each , and is adjacent to only the vertex . Then, for . Consider the vertices in I. Since for every , . We now consider the vertices in C. Recall that . Let . Since and , we know that . Let . Then, . Therefore, h is also an SDF of G. We have .
Following what we have discussed above, we have . The proof for is analogous to that for . Hence, the theorem holds for any -split graphs. □
Theorem 7. The SDP on -split graphs is NP-complete.
Proof. We reduce the (3,2)-
hitting set problem to the SDP on
-split graphs. Let
and let
such that
and
for
. A (3,2)-hitting set for the instance
is a subset
of
U such that
for
. The (3,2)-hitting set problem is to find a minimum (3,2)-hitting set for any instance
. The (3,2)-hitting set problem is NP-complete [
17].
Consider an instance of the (3,2)-hitting set problem. Let , , and . We construct an -split graph by the following steps.
- (1)
Let be an independent set and let be a clique.
- (2)
For each vertex , a vertex is connected to if .
- (3)
For , the vertex is connected to the vertex .
- (4)
For , the vertex is connected to the vertex .
Let be the minimum cardinality of a (3,2)-hitting set for the instance . Assume that is a minimum (3,2)-hitting set for the instance . Then, . Let f be a function whose domain is and range is , and if and if . Clearly, f is an SDF of G. We have .
Assume that f is minimum-weight SDF of G. For each , and is adjacent to only the vertex . Then, for . For any vertex , no matter what values the function f assigns to the vertices in U or in S. Consider the vertices in S. By the construction of G, and for . There are at least three vertices in with the function value 1. If , then there exists an SDF g of G such that and for every . Then, . It contradicts the assumption that the weight of f is minimum. Therefore, there exists a minimum-weight SDF h of G such that for . Notice that for . There are at least two vertices in with the function value 1. Then, the set is a (3,2)-hitting set for the instance . We have .
Following what we have discussed above, we know that . Hence, the SDP on -split graphs is NP-complete. □
Corollary 4. The SCTP and the MCTP on split graphs are NP-complete.
Proof. The corollary holds by Theorems 6 and 7 and the NP-completeness of the MDP on split graphs [
17]. □
7. Planar, Total, and Line Graphs
In a graph, a vertex x and an edge e are incident to each other if e connects x to another vertex. Two edges are adjacent if they share a vertex in common. Let G and H be graphs such that each vertex corresponds to an edge and two vertices are adjacent in H if and only if their corresponding edges and are adjacent in G. Then, H is the line graph of G and denoted by . Let be a graph such that and two vertices are adjacent in H if and only if x and y are adjacent or incident to each other in G. Then, is the total graph of G and denoted by .
Lemma 9 ([
28])
. The following statements hold for any triangle-free graph G.- (1)
Every maximal clique of is the set of edges of G incident to some vertex of G.
- (1)
Two maximal cliques in intersect if and only if their corresponding vertices (in G) are adjacent in G.
Theorem 14. The MCIP is NP-complete for any 4-regular planar graph G with the clique number 3.
Proof. Since
for any planar graph
G [
29], the MCIP on planar graphs is in NP. Let
be the class of triangle-free, 3-connected, cubic planar graphs. The independent set problem remains NP-complete even when restricted to the graph class
[
30]. We reduce this NP-complete problem to the MCIP for 4-regular planar graphs with the clique number 3 as follows.
Let and . Clearly, we can construct H in polynomial time. By Lemma 9, we know that H is a 4-regular planar graph with and each maximal clique is a triangle in H.
Assume that is an independent set of G of maximum cardinality. Since , for every . Let have the vertex in common for . Then, form a triangle in H. Let be the triangle formed by in H for . For each pair of vertices , is not adjacent to in G. Therefore, and in H do not intersect. The set is an MCIS of H. We have .
Assume that is a maximum MCIS of H. Then, each is a triangle in H. Let be formed by in H for . Then, are incident to the same vertex in G. For , let have the vertex in common. For each pair of , and do not intersect. Therefore, is not adjacent to in G. The set is an independent set of G. We have .
Hence, . For , we know that if and only if . □
Corollary 5. The MCIP is NP-complete for line graphs of triangle-free, 3-connected, cubic planar graphs.
Proof. The corollary holds by the reduction of Theorem 14. □
Theorem 15. The MCIP problem is NP-complete for total graphs of triangle-free, 3-connected, cubic planar graphs.
Proof. Since
for a planar graph
G, the MCIP on planar graphs is in NP. Let
be the classes of traingle-free, 3-connected, cubic planar graphs. The independent set problem remains NP-complete even when restricted to the graph class
[
30]. We reduce this NP-complete problem to MCIP for for total graphs of triangle-free, 3-connected, cubic planar graphs. as follows
Let and . Clearly, we can construct H in polynomial time. By Lemma 9, we can verify that H is a 6-regular graph with .
Assume that is an independent set of G of maximum cardinality. Since , for every . Let have the vertex in common. Then, form a maximum clique in H. Let be the maximum clique formed by in H for . For each pair of vertices , is not adjacent to in G. Therefore, and in H do not intersect. The set is an MCIS of H. We have .
Assume that is a maximum MCIS of H. By the construction of H, each is formed by three edge-vertices in and their common end vertex in . Let and in H such that is formed by for . For each pair of , and do not intersect. Therefore, is not adjacent to in G. The set is an independent set of G. We have .
Hence, . For , we know that if and only if . □